c....&...1.........2.........3.........4.........5.........6.........7..
      implicit none
      integer ngr,ig,igrr,isunit,ifile,ipix,npix,itest
      parameter (ngr=63312)
      real*4 xlgmin,xlgmax,xltmin,xltmax
      real*4 xlon,xlat,reslon,reslat
      real*4 ylongi,ylati,cla,sil,san,elv,colour,fland
      character*200 file1,file7,file2
      
      write(*,*)'Region defined as rectangular area or from a file ?'
      write(*,*)'Enter :'
      write(*,*)'0 for rectangular area'
      write(*,*)'1 for reading longitudes and latitudes from a file'
      read(*,*)ifile
      
      if (ifile.eq.0) then
100    continue       
       write(*,*)'Enter minimum longitude in degrees:'
       read(*,*)xlgmin
       if (xlgmin.gt.180.) xlgmin=xlgmin-360.
       if (xlgmin.le.-180.) xlgmin=xlgmin+360.
       write(*,*)'Enter maximum longitude in degrees:'
       read(*,*)xlgmax
       if (xlgmax.gt.180.) xlgmax=xlgmax-360.
       if (xlgmax.le.-180.) xlgmax=xlgmax+360.
       if (xlgmin.gt.xlgmax) then
        write(*,*)'Max longitude smaller than min longitude'
	write(*,*)'Enter new longitude values'
	go to 100 
       endif 
110    continue       
       write(*,*)'Enter minimum latitude in degrees:'
       read(*,*)xltmin 	 
       write(*,*)'Enter maximum latitude in degrees:'
       read(*,*)xltmax
       if ((xltmin.lt.-90.).or.(xltmin.gt.90.)) then 
         write(*,*)'Latitude values not in the range -90, +90'
	 write(*,*)'Enter new latitude values'
	 go to 110
       endif
       if ((xltmax.lt.-90.).or.(xltmax.gt.90.)) then 
         write(*,*)'Latitude values not in the range -90, +90'
	 write(*,*)'Enter new latitude values'
	 go to 110
       endif       
       if (xltmin.gt.xltmax) then
        write(*,*)'Max latitude smaller than min latitude'
	write(*,*)'Enter new latitude values'
	go to 110 
       endif
      else
       write(*,*)'The region to be extracted defined in a file.'
       write(*,*)'The file must contain as many lines as there are'
       write(*,*)'pixels to be extracted. Each line contains the'
       write(*,*)'longitude and latitude in degrees of each pixel.'
       write(*,*)' '             
       write(*,*)'Enter name of file to be used (200 charcters max): '
       read(*,'(a200)')file2
       call count_lines(file2,npix)
       open(2,file=trim(file2))
      endif
      
      reslon=0.5
      reslat=0.5            
        
      file1='/raid/umccb/francois/caraib_nc/clim/ISI_MIP/'//
     &'ecotxt_ISI_MIP_COR1.dat'

      open(1,file=file1)     

      write(*,*)'Enter name of output ecotxt file (200 charcters max): '
      read(*,'(a200)')file7      
c      file7='/raid3/umccb/clim0017/stufrancois/caraib_2020/caraib/clim/'
c     &//'WEurope/ecotxt.dat'
     
      open(7,file=trim(file7))
     
c      xlgmin=-12.
c      xlgmax=30.
c      xltmin=35.
c      xltmax=65.
      
      if (ifile.eq.0) then            
       do ig=1,ngr
        read(1,*)igrr,ylongi,ylati,isunit,cla,sil,san,elv,colour,fland
        if((ylongi.ge.xlgmin).and.(ylongi.le.xlgmax))then
         if((ylati.ge.xltmin).and.(ylati.le.xltmax))then
	  write(7,123)
     &    igrr,ylongi,ylati,isunit,cla,sil,san,elv,colour,fland
         endif
        endif
       end do
      else
       do ipix=1,npix
        read(2,*)xlon,xlat	
        do ig=1,ngr
         read(1,*)igrr,ylongi,ylati,isunit,cla,sil,san,elv,colour,fland
	 xlgmin=xlon-0.5*reslon
	 xlgmax=xlon+0.5*reslon	 
         if((ylongi.ge.xlgmin).and.(ylongi.lt.xlgmax))then
	  xltmin=xlat-0.5*reslat
	  xltmax=xlat+0.5*reslat		 
          if((ylati.ge.xltmin).and.(ylati.lt.xltmax))then
	   write(7,123)
     &     igrr,ylongi,ylati,isunit,cla,sil,san,elv,colour,fland
           go to 210
          endif
         endif
        end do
	write(*,*)'Pixel not found in continental grid:',ipix,xlon,xlat
210	continue
        rewind (1)
       end do	
      endif
      
123   format(i7,2(1x,f9.4),1x,i3,3(1x,f6.2),1x,f5.0,1x,f5.2,1x,f6.3)

      close (1)
      close (2)
      close (7)
      stop
      end
      
      
c***********************************************************************      
      subroutine count_lines(filename,nlines)
c***********************************************************************      
      implicit none
      character*200 filename
      character*250 command
      integer nlines
      
      command='wc '//trim(filename)//' > ./tmp/nlines.tmp'
      call system(command)
      open(99,file='./tmp/nlines.tmp')
      read(99,*)nlines
      close (99)
      
      command='rm ./tmp/nlines.tmp'
      call system(command)
            
      return
      end      
