
      implicit none
      
      integer nmx,ngrmx
      parameter (nmx=12,ngrmx=140000)
c  ngrmx = maximum number of pixels in the global climatological data
c  CAUTION: if you change ngrmx, you must also change it
c  in the subroutines

      integer ngr_hr,ngr,ig,im,nm,icount,kg,ntry
      integer igrr,isunit,isu,nnn
      real*8 cla,sil,san,patm0,patm,aaa,bbb,ccc,elv1,dangl,dlg,dlt
     &      ,dist2
      
      real*8 temact(nmx),prcact(nmx),elvact
     &         ,shract(nmx),rhuact(nmx),dteact(nmx)
     &         ,wndact(nmx),qvact(nmx),preact(nmx),fsolact(nmx)
      real*8 temp(ngrmx,nmx),prcp(ngrmx,nmx),elvp(ngrmx)
     &         ,shrp(ngrmx,nmx),rhup(ngrmx,nmx),fsolp(ngrmx,nmx)
     &         ,dtep(ngrmx,nmx),wndp(ngrmx,nmx),qvp(ngrmx,nmx)
     &         ,prep(ngrmx,nmx)     
      real*8 xlg(ngrmx),xlt(ngrmx),xlg1,xlt1,xlg2,xlt2
      
      common /earth/ radius,pi180      
      real*8 radius,pi180
      
      real*8 dist(ngrmx)
      integer igri(ngrmx),num          
      real*8 tk,es
                      
      integer npoints,isol,iclim,iecotxt
       
      character*3 name
      character*40 wform
      character*200 dir,dir_out
      character*200 fileco_hr,filtem_hr
      integer iyear
      character*20 year      
      
c   number of grid points in the high resolution grid (interpolated)     
      ngr_hr = 17229
            
c   iclim : selects climatological data to be used : 
c        0 = Princeton (PGFv2)
c        1 = CRU
c        2 = CRU (old version 1901-2006) 
c        3 = user-prescribed (e.g., MAR)
c        4 = COSMO outputs     
      iclim = 4

c   number of neighbours used in the interpolation      
      npoints=4

c   directory+filename of high resolution grid (ecotxt)       
      fileco_hr='../clim/Wallonia/ecotxt.dat'       
      
c   directory+filename of high resolution temperature file (tem.dat)    
       filtem_hr='../clim/Luxemburg/2min/tem_WC.dat'
      
c   directory of output files (interpolated results)
      dir_out='../clim/Luxemburg/2min/'            
       
c =====================================================================       

      nm = 12
      radius = 6370.
      pi180 = 3.1415926535/180.
      
      patm0 = 1.013d+5


      
      if (iclim.eq.0) then
        
      ngr = 67404
      dir = '/raid/umccb/francois/caraib_nc/clim/ISI_MIP/Hist/PGFv2/'
      
      open(11,file=TRIM(dir)//'temMEAN1951_2000.dat')
  
      open(12,file=TRIM(dir)//'prcMEAN1951_2000.dat')
      
      isol=1
      open(13,file=TRIM(dir)//'fsolMEAN1951_2000.dat')
      
      open(14,file=TRIM(dir)//'rhuMEAN1951_2000.dat')
      
      open(15,file=TRIM(dir)//'winMEAN1951_2000.dat')

      open(17,file=TRIM(dir)//'dteMEAN1951_2000.dat')
      
      iecotxt = 1

      open(19,file='/raid/umccb/francois/caraib_nc/clim/ISI_MIP/'//
     &'ecotxt_ISI_MIP_COR.dat')
     
      elseif (iclim.eq.1) then
      
      ngr = 60143
      dir = '/raid3/umccb/migou/home/dury/clim/CRU/'
      
      open(11,file=TRIM(dir)//'GL05_TS4/temMEAN1971_2000.dat')
  
      open(12,file=TRIM(dir)//'GL05_TS4/prcMEAN1971_2000.dat')
      
      isol=0
      open(13,file=TRIM(dir)//'GL05_TS4/shrMEAN1971_2000.dat')
      
      open(14,file=TRIM(dir)//'GL05_TS4/rhuMEAN1971_2000.dat')
      
      open(15,file=TRIM(dir)//'GL05/wnd.dat')

      open(17,file=TRIM(dir)//'GL05_TS4/dteMEAN1971_2000.dat')
      
      iecotxt = 1
      open(19,file=
     &'/raid3/umccb/migou/home/dury/clim/CRU/GL05/ecotxt.dat')

      elseif (iclim.eq.2) then
      
      ngr = 60143
      dir = '/work1/umccb/francois/clim/CRU/GL05/'
      
      open(11,file=TRIM(dir)//'temMEAN1951_2000.dat')
  
      open(12,file=TRIM(dir)//'prcMEAN1951_2000.dat')
      
      isol=0
      open(13,file=TRIM(dir)//'shrMEAN1951_2000.dat')
      
      open(14,file=TRIM(dir)//'rhuMEAN1951_2000.dat')
      
      open(15,file=TRIM(dir)//'wndMEAN1951_2000.dat')

      open(17,file=TRIM(dir)//'dteMEAN1951_2000.dat')
      
      iecotxt = 1
      open(19,file='/work1/umccb/francois/clim/CRU/GL05/ecotxt.dat')    
      
      elseif (iclim.eq.3) then
c user-prescribed climatological data to be interpolated      
      ngr = 6264
      dir =
     &'/raid/umccb/clim0017/stufrancois/caraib_2016/clim/Madag/MAR/'
     
      write(*,*)'Interpolation for which year ?'
      read(*,*)year
      write(*,*),'Starting interpolation for year: ',year
      
      open(11,file=TRIM(dir)//'tem'//trim(year)//'.dat')
  
      open(12,file=TRIM(dir)//'prc'//trim(year)//'.dat')
      
      isol=0
      open(13,file=TRIM(dir)//'shr'//trim(year)//'.dat')
      
      open(14,file=TRIM(dir)//'rhu'//trim(year)//'.dat')
      
      open(15,file=TRIM(dir)//'wnd'//trim(year)//'.dat')

      open(17,file=TRIM(dir)//'dte'//trim(year)//'.dat')
      
      iecotxt = 0
      open(19,file=TRIM(dir)//'elev.dat') 
      
      else           
      
      write(*,*)'Wrong value of iclim: ',iclim
      write(*,*)'Program stop'
      stop
          
      endif

      write(*,*)'Reads input climatological files'
c === Reads GCM results for control run simulation ====================
c On lit les fichiers GCM pour le run de controle 
c Les unites utilisees dans ces fichiers sont precisees ici

      do ig = 1, ngr 
        read(11,*)xlg(ig),xlt(ig),(temact(im),im=1,nm)

        read(12,*)xlg(ig),xlt(ig),(prcact(im),im=1,nm)
	if (isol.eq.0) then
	 read(13,*)xlg(ig),xlt(ig),(shract(im),im=1,nm)
	else
         read(13,*)xlg(ig),xlt(ig),(fsolact(im),im=1,nm)
        endif
        read(14,*)xlg(ig),xlt(ig),(rhuact(im),im=1,nm)
        read(15,*)xlg(ig),xlt(ig),(wndact(im),im=1,nm)
c       read(16,*)(wndact2(im),im=1,nm)
	read(17,*)xlg(ig),xlt(ig),(dteact(im),im=1,nm)
c	read(18,*)(dteact2(im),im=1,nm)
        if (iecotxt.eq.1) then
         read(19,*)igrr,xlg(ig),xlt(ig),isunit,cla,sil,san,elvp(ig)
	else
         read(19,*)igrr,xlg(ig),xlt(ig),elvp(ig)
	endif
        patm = patm0 - 11.5*elvp(ig) + 5.44d-4*elvp(ig)*elvp(ig)
c   corrections si necessaire

c	do im=1,nm
c	 dteact(im)=0.
c   =0 si cas ou on a pas de dte  
c	 shract(im)=100.-shract(im)
c   100-total_cloud_cover=heures d'ensoleillement en %	 
c	 rhuact(im)=100.*rhuact(im)
c   ne sait pas pourquoi fait *100

c   Place des limites pour les pourcentages deja fait pour plasim
	do im=1,nm
         preact(im) = patm            
         if (rhuact(im).lt.5.) rhuact(im)=5.
         if (rhuact(im).gt.100.) rhuact(im)=100.
         if (isol.eq.0) then
          if (shract(im).lt.0.) shract(im)=0.
          if (shract(im).gt.100.) shract(im)=100.
	 endif	 	 
c	 dteact(im)=2.*temact(im)-2.*dteact(im)
c	end do
         tk = temact(im)+273.15
         call esat (tk,es)
	 
	 qvact(im) = 0.622*(rhuact(im)/100.)*es/preact(im)
         
	 temp(ig,im)=temact(im)
	 dtep(ig,im)=dteact(im)	 
	 prcp(ig,im)=prcact(im)
	 if (isol.eq.0) then	 
	  shrp(ig,im)=shract(im)
	 else
	  fsolp(ig,im)=fsolact(im)
	 endif
	 rhup(ig,im)=rhuact(im)
	 wndp(ig,im)=wndact(im)
	 qvp(ig,im)=qvact(im)
	 prep(ig,im)=preact(im)	 	 	 
	end do
       
      end do

      
       close (11)
       close (12)
       close (13)
       close (14)
       close (15)
       close (16)
       close (17)
       close (18)
       close (19)
           
       write(*,*)'End of climatological files reading'
       write(*,*)'Begins interpolation' 
    
      
c ==== INTERPOLATES, CALCULATES ANOMALIES AND PRINTS RESULTS ==========
c  Ici on a besoin d'une climatologie actuelle pour calculer les anomalies
c  Il faut aussi fournir le masque passe
c  Interpollation en 2 etapes
c  1. champs GCM globaux sur masque passe avec interp
c  2. champs clim continentaux sur masque passe avec interp_r
c     et recherche des proches voisins pour recouvrement
      
c      write(*,*)'Interpolation champs GCM sur masque passe'      
c      write(*,*)'Interpolation champs New sur masque torto'     


c    HAUTE RESOLUTION GRID (ecotxt)
      open(40,file=TRIM(fileco_hr))    

c    TEMPERATURE HIGH RESOLUTION 
      open(81,file=TRIM(filtem_hr))
      

c     FICHIERS RESULTATS INTERPOLES

c      open(82,file=TRIM(dir_out)//'prc_WC.dat')
      if (isol.eq.0) then	 
        open(83,file=TRIM(dir_out)//'shr_WC1.dat')
      else
        open(83,file=TRIM(dir_out)//'fsol_WC1.dat')
      endif  
  
      open(84,file=TRIM(dir_out)//'rhu_WC1.dat') 
c      open(85,file=TRIM(dir_out)//'dte_WC.dat')  
      open(86,file=TRIM(dir_out)//'wnd_WC1.dat')  
      open(87,file=TRIM(dir_out)//'alt_WC1_int.dat')     


cccccccccccccccccccccccccccccccccccccccccc

      open(10,file='./numpix.res') 
            

      icount = 0
      do kg = 1, ngr_hr
       icount=icount+1      
       if (icount.eq.1)write(*,*)'Point Nr: ',kg
       if (icount.eq.1000)icount=0
       read(40,*)nnn,xlg1,xlt1,isu,aaa,bbb,ccc,elv1 
       read(81,*)aaa,bbb,(temact(im),im=1,nm)      
       dangl = 1. !(70./111.) !(25./111.)
       ntry = 0
2000   continue       
       num = 0
       do ig = 1, ngr
        dlg = dabs(xlg(ig)-xlg1)
c	dangl_lg = dangl/dcos(xlt(ig)*pi180)
	if(dlg.le.dangl)then	
c	 write(*,*) 'coucou'
	 dlt = dabs(xlt(ig)-xlt1)
	 if(dlt.le.dangl)then
c	  write(*,*) 'coucou2'
	  num=num+1
	  igri(num)=ig
	  xlg2 = xlg(ig)
	  xlt2 = xlt(ig)
          call distance(xlg1,xlt1,xlg2,xlt2,dist2)
	  dist(num)=dist2 
	 endif
	endif
       end do


       if (ntry.gt.100) then
         write(*,*)'Ntry too large: ', ntry,' ig: ',ig
	 stop
       endif 
       if (num.lt.npoints) then 
         dangl = dangl*1.5
	 ntry = ntry + 1
	 go to 2000
       endif

       write(10,'(2(1x,f9.4),1x,i3)')xlg1,xlt1,num
       
       call sort(dist,igri,num)
       
       
         
       num = npoints      
       
       call interp_r(elvp,elvact,dist,igri,num,1)
c       call interp_r(temp,temact,dist,igri,num,nm)
c       call interp_r(prcp,prcact,dist,igri,num,nm)
       if (isol.eq.0) then
         call interp_r(shrp,shract,dist,igri,num,nm)
       else
         call interp_r(fsolp,fsolact,dist,igri,num,nm)
       endif
c       call interp_r(rhup,rhuact,dist,igri,num,nm)
       call interp_r(qvp,qvact,dist,igri,num,nm) 
c       call interp_r(dtep,dteact,dist,igri,num,nm)      
       call interp_r(wndp,wndact,dist,igri,num,nm) 
       
       patm = patm0 - 11.5*elv1 + 5.44d-4*elv1*elv1
            
       do im = 1, nm
        tk = temact(im)+273.15
        call esat (tk,es)
        rhuact(im) = 100.*qvact(im)*patm/(0.622*es)
	
        if (rhuact(im).lt.5.) rhuact(im)=5.
	if (rhuact(im).gt.100.) rhuact(im)=100.
	if (isol.eq.0) then
	 if (shract(im).lt.0.) shract(im)=0.
	 if (shract(im).gt.100.) shract(im)=100.
	endif
       end do

c      Ecriture dans fichiers resultats
c       write(*,*)'Writing results for grid point: ',kg

cc       write(wform,*)'(2(1x,f9.4),',nm,'(1x,f8.3))'                    
cc       write(81,wform)xlg1,xlt1,(temact(im),im=1,nm)
 
c       write(wform,*)'(2(1x,f9.4),',nm,'(1x,f10.3))'       
c       write(82,wform)xlg1,xlt1,(prcact(im),im=1,nm)
       if (isol.eq.0) then
        write(wform,*)'(2(1x,f9.4),',nm,'(1x,f8.3))'       
        write(83,wform)xlg1,xlt1,(shract(im),im=1,nm)
       else
        write(wform,*)'(2(1x,f9.4),',nm,'(1x,f8.3))'       
        write(83,wform)xlg1,xlt1,(fsolact(im),im=1,nm)
       endif
       
       write(wform,*)'(2(1x,f9.4),',nm,'(1x,f8.3))'       
       write(84,wform)xlg1,xlt1,(rhuact(im),im=1,nm)
       
c       write(wform,*)'(2(1x,f9.4),',nm,'(1x,f8.3))'       
c       write(85,wform)xlg1,xlt1,(dteact(im),im=1,nm)
       
       write(wform,*)'(2(1x,f9.4),',nm,'(1x,f8.3))'       
       write(86,wform)xlg1,xlt1,(wndact(im),im=1,nm)   
           
       write(wform,*)'(2(1x,f9.4),',1,'(1x,f8.3))'       
       write(87,wform)xlg1,xlt1,elvact  

c     fin de la boucle finale sur nombre points masque passe
      end do


 
      close (40)
c      close (45)

c      close (50)
c      close (51)
c      close (52)
c      close (53)
c      close (54)
c      close (55)
c      close (56)
             
c      close (71)
c      close (72)
c      close (73)
c      close (74)

ccc      enddo

      close (81)
      close (82)
      close (83)
      close (84)
      close (85)
      close (86)
      close (87)          

      write(*,*)'End of program'                
		
      stop
      end

   
       
ccccc&cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine esat (tk,es)
ccccc&cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      implicit none

      real*8 tk,es
      real*8 asat,bsat,csat,temp0,psat0,eaice,rgas
     
c----------------------------------------------------------------------
c  This subroutine calculates saturation vapour pressure of H2O.
c  INPUT :  tk = temperature [K]
c  OUTPUT : es = saturated vapour pressure of H2O [Pa]
c----------------------------------------------------------------------

      asat=6763.6d+0
      bsat=4.9283d+0
      csat=54.233d+0
      temp0 = 273.15d+0

      if (tk.ge.temp0) then
        es = 100.*dexp(-asat/tk-bsat*dlog(tk)+csat)
       else
        psat0=100.*dexp(-asat/temp0-bsat*dlog(temp0)+csat)
        eaice = 51012.
	rgas = 8.314
        es = psat0*dexp(eaice*(tk-temp0)/(rgas*tk*temp0))
      endif

      return
      end 
      
            


c ********************************************************************** 
      subroutine interp_r(varint,vari,dist,idat,num,nm)
c **********************************************************************
      implicit none      
 
      integer nmx,ngrmx
      parameter (ngrmx=140000)  

      integer idat(ngrmx),num,nm         
      real*8 varint(ngrmx,nm),vari(nm),dist(ngrmx)
      
      integer m,k,ig
      real*8 sumwgt,weight
                  
      sumwgt = 0.
      do m = 1, nm
       vari(m)=0.
      end do      

      do k = 1, num
        ig = idat(k)
        if (dist(k).le.1.d-4) then	
	  do m = 1, nm
	   vari(m)=varint(ig,m)
	  end do
	  go to 1000
	else
	  weight = 1./dist(k)
	  sumwgt = sumwgt + weight
	  do m = 1, nm
           vari(m)=vari(m)+varint(ig,m)*weight
	  end do
        endif
      end do
      
      do m = 1,nm
       vari(m) = vari(m)/sumwgt
      end do
      
1000  continue
      return
      end

      
      
      
       
c ********************************************************************** 
      subroutine distance(xlg1,xlt1,xlg2,xlt2,distx)
c **********************************************************************
      implicit none      

      real*8 xlg1,xlt1,xlg2,xlt2,distx
      common /earth/ radius,pi180
      real*8 radius,pi180
      real*8 c1,c2,s1,s2,cdlg,argu
c 
c   xlg1,xlt1 = long, lat of first point (deg)
c   xlg2,xlt2 = long, lat of second point (deg)
c   radius = Earth radius (km)
c   pi180 = 3.1415926535/180. 
c   dist = distance (km)

c obligation de preciser l'arrondi pour passage a 1 ou -1 sinon
c  fonction acos considere que c'est hors dom def. (>1 ou <-1)
c  d'ou NAN

       c1 = dcos(xlt1*pi180)
       c2 = dcos(xlt2*pi180)
       s1 = dsin(xlt1*pi180)
       s2 = dsin(xlt2*pi180)       
       cdlg = dcos((xlg2-xlg1)*pi180) 
       argu = s1*s2+c1*c2*cdlg
       if (argu.ge.0.999999999)argu=0.999999999 
       if (argu.le.-0.999999999)argu=-0.999999999     
       distx = radius*dacos(argu)       
       
       
       return
       end
       

              
       
       
c=======================================================================      
      subroutine sort(xdat,idat,n)
c=======================================================================
     
      implicit none
      integer ngrmx
      parameter (ngrmx=140000)
      dimension xdat(ngrmx),idat(ngrmx)
      real*8 xdat,xdat2
      integer n,jtest,i,idat,idat2


100   continue      
      jtest = 0
     
      
      do i=1,n-1
        if (xdat(i).gt.xdat(i+1)) then
	  jtest = jtest+1
	  xdat2 = xdat(i+1)
	  idat2 = idat(i+1)
	  xdat(i+1) = xdat(i)
	  idat(i+1) = idat(i)
	  xdat(i) = xdat2
	  idat(i) = idat2
	endif
      end do
      
      if (jtest.ge.1) go to 100
      
      return
      end 
       
